from django.urls import path

from leftists.views import (CoolerLoginView, LinkCreateView, LinkDeleteView,
                            LinkListView, LinkUpdateView, OverView,
                            ShortLinkRedirectView)

urlpatterns = [
    path('', CoolerLoginView.as_view(), name='login'),
    path('iface/overview', OverView.as_view(), name='interface.overview'),
    path('iface/link/create', LinkCreateView.as_view(), name='interface.link.create'),
    path('iface/link/update/<str:slug>', LinkUpdateView.as_view(), name='interface.link.update'),
    path('iface/link/delete/<str:slug>', LinkDeleteView.as_view(), name='interface.link.delete'),
    path('iface/<str:domain>/links', LinkListView.as_view(), name='interface.link.list'),
    path('<str:link>', ShortLinkRedirectView.as_view(), name='link-redirect'),
]
